// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// AutobinDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Autobin.h"
#include "AutobinDlg.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAutobinDlg _CAO

CAutobinDlg::CAutobinDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAutobinDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAutobinDlg)
	m_autobin = -1;
	m_stparam1 = _T("");
	m_stparam2 = _T("");
	m_stparam3 = _T("");
	m_stparam4 = _T("");
	m_stparam5 = _T("");
	m_param1 = 0;
	m_param2 = 0;
	m_param3 = 0;
	m_param4 = 0;
	m_param5 = 0;
	m_exequtetime = _T("0");
	m_blnVideoOpened = false;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAutobinDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAutobinDlg)
	DDX_CBIndex(pDX, IDC_AUTOBIN, m_autobin);
	DDX_Text(pDX, IDC_STATIC1, m_stparam1);
	DDX_Text(pDX, IDC_STATIC2, m_stparam2);
	DDX_Text(pDX, IDC_STATIC3, m_stparam3);
	DDX_Text(pDX, IDC_STATIC4, m_stparam4);
	DDX_Text(pDX, IDC_STATIC5, m_stparam5);
	DDX_Text(pDX, IDC_PARAM1, m_param1);
	DDX_Text(pDX, IDC_PARAM2, m_param2);
	DDX_Text(pDX, IDC_PARAM3, m_param3);
	DDX_Text(pDX, IDC_PARAM4, m_param4);
	DDX_Text(pDX, IDC_PARAM5, m_param5);
	DDX_Text(pDX, IDC_EXEQUTETIME, m_exequtetime);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAutobinDlg, CDialog)
	//{{AFX_MSG_MAP(CAutobinDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_EXEREGION, OnExeregion)
	ON_CBN_SELCHANGE(IDC_AUTOBIN, OnSelchangeAutobin)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_EXEQUTE, OnExequte)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAutobinDlg bZ[W nh

BOOL CAutobinDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize( NULL );
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no = 0;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface( __uuidof(IFvxDisplayEx2Ptr) , (void**)&m_FvxDisplayEx );

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxChangeImage.CreateInstance( __uuidof( FvxChangeImage ) ); 
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImage1.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImage2.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_FvxROI.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvRectangle.CreateInstance( __uuidof( FvRectangle ) ); 
			
		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay( 1 , 0 );

		// ͈͂̏lݒi摜̑Oʂɐݒj
		m_FvRectangle->Putxs( -1 );
		m_FvRectangle->Putxe( -1 );
		m_FvRectangle->Putys( -1 );
		m_FvRectangle->Putye( -1 );
	
		// Rg[ނ̏
		CComboBox*    pcmb = ( CComboBox* )GetDlgItem( IDC_AUTOBIN );
		pcmb->AddString( "ŒQl" );
		pcmb->AddString( "ʕ͖@" );
		pcmb->AddString( "P^C@" );
		pcmb->AddString( "vVAqXgO" );
		pcmb->AddString( "ꎟqXgO" );
		pcmb->AddString( "ŏlEől͈͓" );
		pcmb->AddString( "Ǐ̈敽ϒl" );
		pcmb->AddString( "̈臒l" );
		m_autobin = 0;
		UpdateData(FALSE); 
		OnSelchangeAutobin();

		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ) );

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep( 350 );

			// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize(m_FvxImage1);

            // QlpɎgpC[W̃TCY낦Ă
            m_FvxImage2->PutImageType( m_FvxImage1->GetImageType() );
            m_FvxImage2->PutImageHeight( m_FvxImage1->GetImageHeight() );
            m_FvxImage2->PutImageWidth( m_FvxImage1->GetImageWidth() );

			try	{

				// 捞
				m_FvxVideo->GrabSync( m_FvxImage1 );

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem( IDC_GRAB )->EnableWindow( TRUE );
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_FvxDisplayEx->DrawImage( m_FvxImage1 );


	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CAutobinDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CAutobinDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// 摜t@CǍ
void CAutobinDlg::OnLoadimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr=0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜`FbN
		if (( m_FvxImage1->GetBitPerPixel()!=8 ) || ( m_FvxImage1->GetImageType ()!=imageGray )){

			MessageBox("8bitO[摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImage1->PutBitPerPixel( 8 );
            m_FvxImage1->PutImageType( imageGray );
            m_FvxImage1->PutImageWidth( 512 );
            m_FvxImage1->PutImageHeight( 480 );

		}

		m_FvxDisplayEx->DrawImage( m_FvxImage1 );

        // QlpɎgpC[W̃TCY낦Ă
        m_FvxImage2->PutImageType( m_FvxImage1->GetImageType() );
        m_FvxImage2->PutImageHeight( m_FvxImage1->GetImageHeight() );
        m_FvxImage2->PutImageWidth( m_FvxImage1->GetImageWidth() );
	
	}
	
}

// 摜t@Cۑ
void CAutobinDlg::OnSaveimage() 
{

	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr=0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}	
}

// GRAB
void CAutobinDlg::OnGrab() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
	m_FvxVideo->ChangeImageSize(m_FvxImage1);

	try{

		m_FvxVideo->GrabSync(m_FvxImage1);

	}catch(_com_error ){
		long lngErr = 0;
		CString cStr;
		
		m_FvxVideo->GetErrReport( &lngErr );
		cStr.Format("err_no = %d", lngErr );
		MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
		return;
	}

	m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	
}

// ͈
void CAutobinDlg::OnExeregion() 
{

	long lngOK = 0;
	double dblTemp = 0;
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    m_FvxROI->SetRectangle( m_FvRectangle );

    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI->PutUsePoint( false );
    m_FvxROI->MakeROIDialog( m_FvxImage1, &lngOK);

    if ((lngOK == 1) && (m_FvxROI->GetCheckRectangle() == 1)) {
        m_FvxROI->GetRectangle( m_FvRectangle );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        if ( m_FvRectangle->Getxe() < m_FvRectangle->Getxs() ) {
            dblTemp = m_FvRectangle->Getxs();
			m_FvRectangle->Putxs( m_FvRectangle->Getxe() );
            m_FvRectangle->Putxe( dblTemp );
		}
		if ( m_FvRectangle->Getye() < m_FvRectangle->Getys() ) {
            dblTemp = m_FvRectangle->Getys();
            m_FvRectangle->Putys( m_FvRectangle->Getye() );
            m_FvRectangle->Putye( dblTemp );
		}
	}


}

void CAutobinDlg::OnSelchangeAutobin() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	UpdateData( TRUE );

	m_stparam1 = "Param1";
	m_stparam2 = "Param2";
	m_stparam3 = "Param3";
	m_stparam4 = "Param4";
	m_stparam5 = "Param5";
	GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC2 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC3 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC4 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATIC5 )->ShowWindow( SW_HIDE );

	m_param1 = 0;
	m_param2 = 0;
	m_param3 = 0;
	m_param4 = 0;
	m_param5 = 0;
	GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PARAM2 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PARAM3 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PARAM4 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PARAM5 )->ShowWindow( SW_HIDE );

	switch(	m_autobin ) {
		case 0:	 // ŒQl
	        m_stparam1 = "臒l";
		    m_param1 = 128;
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			break;

		case 1:  // ʕ͖@
			break;

		case 2:  // o^C@
			m_stparam1 = "QlS";
			m_param1 = 50;
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			break;

		case 3:  // vVAqXgO
			m_stparam1 = "EdgeFactor";
			m_param1 = 50;
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			break;

		case 4:  // ꎟqXgO
			m_stparam1 = "EdgeFactor";
			m_param1 = 50;
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			break;

		case 5:  // ŏlEől͈͓
			m_stparam1 = "ŏl";
			m_param1 = 96;
			m_stparam2 = "ől";
			m_param2 = 192;
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_STATIC2 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM2 )->ShowWindow( SW_SHOW );
			break;

		case 6:  // Ǐ̈敽ϒl
			m_stparam1 = "Ǐ̈TCY";
			m_param1 = 25;
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			break;

		case 7:  // ̈臒l
			m_stparam1 = "";
			m_param1 = 10;
			m_stparam2 = "c";
			m_param2 = 10;
			m_stparam3 = "MatchAve";
			m_param3 = 10;
			m_stparam4 = "MatchStddev";
			m_param4 = 10;
			m_stparam5 = "wix";
			m_param5 = 30;
    
			GetDlgItem( IDC_STATIC1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_STATIC2 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_STATIC3 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_STATIC4 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_STATIC5 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM2 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM3 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM4 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM5 )->ShowWindow( SW_SHOW );
			break;

		default:
			break;
	}

	UpdateData( FALSE );

}


// NA
void CAutobinDlg::OnClear() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	
}


// s
void CAutobinDlg::OnExequte() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	//long lngErr;
	CString cStr;
    double dblTime = 0 ; 
    long lngParam1 = 0,lngParam2 = 0,lngParam3 = 0,lngParam4 = 0,lngParam5 = 0;

	if (! UpdateData( TRUE )) return;

    lngParam1 = m_param1;
    lngParam2 = m_param2;
    lngParam3 = m_param3;
    lngParam4 = m_param4;
    lngParam5 = m_param5;

	// ͈͂̓Kp
    m_FvxChangeImage->SetInspectArea( m_FvRectangle );

    // o͑̃C[WNA
    m_FvxImage2->ClearImage();

	try {

		switch(	m_autobin ) {
			case 0:	 // ŒQl
				if (( lngParam1 < 0 ) || ( lngParam1 > 255 )) {
					MessageBox("臒l 0`255 ̊ԂŎw肵Ă" , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->FixedLevel( m_FvxImage1 , m_FvxImage2 , lngParam1 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 1:  // ʕ͖@
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->Discrimination( m_FvxImage1 , m_FvxImage2 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 2:  // o^C@
				if (( lngParam1 < 0 ) || ( lngParam1 > 100 )) {
					MessageBox("QlS 0`100 ̊ԂŎw肵Ă" , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->Ptile( m_FvxImage1 , m_FvxImage2 , lngParam1 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 3:  // vVAqXgO
				if (( lngParam1 < 0 ) || ( lngParam1 > 100 )) {
					MessageBox("EdgeFactor 0`100 ̊ԂŎw肵Ă" , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->LapHist( m_FvxImage1 , m_FvxImage2 , lngParam1 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 4:  // ꎟqXgO
				if (( lngParam1 < 0 ) || ( lngParam1 > 100 )) {
					MessageBox("EdgeFactor 0`100 ̊ԂŎw肵Ă" , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->GradHist( m_FvxImage1 , m_FvxImage2 , lngParam1 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 5:  // ŏlEől͈͓
				if (( lngParam1 < 0 ) || ( lngParam1 > 255 )) {
					MessageBox("ŏl 0`255 ̊ԂŎw肵Ă" , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				if (( lngParam2 < 0 ) || ( lngParam2 > 255 )) {
					MessageBox("ől 0`255 ̊ԂŎw肵Ă" , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				if ( lngParam1 > lngParam2 ) {
					MessageBox("ŏlőlƂȂ悤w肵Ă" , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->MinMaxLevel( m_FvxImage1 , m_FvxImage2 , lngParam1 , lngParam2 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 6:  // Ǐ̈敽ϒl
				if (( lngParam1 < 3 ) || (( lngParam1 % 2 ) == 0 )) {
					MessageBox("Ǐ̈TCY 3ȏ̊w肵Ă" , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->ShiftAve( m_FvxImage1 , m_FvxImage2 , lngParam1 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			case 7:  // ̈臒l

				if (( lngParam1 < 1 ) || ( lngParam1 > m_FvxImage1->GetImageWidth() - 1 )) {
					cStr.Format(" 1`%d͈̔͂œ͂ĂB", m_FvxImage1->GetImageWidth() - 1 );
					MessageBox(cStr , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				else if (( lngParam2 < 1 ) || ( lngParam2 > m_FvxImage1->GetImageHeight() - 1 )) {
					cStr.Format("c 1`%d͈̔͂œ͂ĂB", m_FvxImage1->GetImageHeight() - 1 );
					MessageBox(cStr , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				else if (( lngParam3 < 0 ) || ( lngParam3 > 255 )) {
					MessageBox("MatchAve 0`255 ͈̔͂œ͂Ă" , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				else if (( lngParam4 < 0 ) || ( lngParam4 > 255 )) {
					MessageBox("MatchStddev 0`255 ͈̔͂œ͂Ă" , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				else if (( lngParam5 <= 0 ) || ( lngParam5 >= 100 )) {
					MessageBox("wix 1`99 ͈̔͂œ͂Ă" , "p[^G[" ,MB_ICONWARNING | MB_OK);
					return;
				}
				m_FvxPerformanceCounter->StartCount(); 
				m_FvxChangeImage->PartDivid( m_FvxImage1 , m_FvxImage2 , lngParam1 , lngParam2 , lngParam3 , lngParam4 , lngParam5);
				m_FvxPerformanceCounter->StopCount( &dblTime );
				break;

			default:
				break;
		}

	} catch (_com_error) {

		long lngErr = 0;
		CString cStr;

		m_FvxChangeImage->GetErrReport( &lngErr );

		switch ( lngErr ) {
			case 0:
				cStr.Format("G[");
				break;
			case 1501:
				cStr.Format("Ɏs܂Berr_no = %d", lngErr );
				break;
			case 1505:
				cStr.Format("p[^Ⴂ܂Berr_no = %d", lngErr );
				break;
			case 1506:
				cStr.Format("̌^Ⴂ܂Berr_no = %d", lngErr );
				break;
			case 1507:
				cStr.Format("NULLw肳Ă܂Berr_no = %d", lngErr );
				break;
			case 1531:
				cStr.Format("ΏۃC[ŴwTCÝA32̔{łȂ΂Ȃ܂Berr_no = %d", lngErr );
				break;
			case 1532:
				cStr.Format("ΏۃC[Wƌʊi[C[ẂATCYłȂ΂Ȃ܂Berr_no = %d", lngErr );
				break;
			case 1550:
				cStr.Format("C[W̎ނႢ܂Berr_no = %d", lngErr );
				break;
			case 1551:
				cStr.Format("ΏۃC[Wƌʊi[C[WɁÃIuWFNgw肳Ă܂Berr_no = %d", lngErr );
				break;
			case 1552:
				cStr.Format("͈͂̎wɊԈႢ܂Berr_no = %d", lngErr );
				break;
			default:
				cStr.Format("sȃG[ err_no = %d", lngErr );
				break;
		}

		MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
		return;
	}

	m_FvxDisplayEx->DrawImage( m_FvxImage2 );
	m_exequtetime.Format("%fms", dblTime );
	UpdateData( FALSE );
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CAutobinDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CAutobinDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CAutobinDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
	
}

void CAutobinDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
    // rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
}
